# coding: utf-8

"""
    Tator REST API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tator.api_client import ApiClient


class MembershipApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_membership(self, project, **kwargs):  # noqa: E501
        """create_membership  # noqa: E501

        Create or retrieve a list of project memberships.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_membership(project, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int project: A unique integer identifying a project. (required)
        :param Body14 body:
        :return: InlineResponse2005
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_membership_with_http_info(project, **kwargs)  # noqa: E501
        else:
            (data) = self.create_membership_with_http_info(project, **kwargs)  # noqa: E501
            return data

    def create_membership_with_http_info(self, project, **kwargs):  # noqa: E501
        """create_membership  # noqa: E501

        Create or retrieve a list of project memberships.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_membership_with_http_info(project, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int project: A unique integer identifying a project. (required)
        :param Body14 body:
        :return: InlineResponse2005
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_membership" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project' is set
        if ('project' not in params or
                params['project'] is None):
            raise ValueError("Missing the required parameter `project` when calling `create_membership`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project' in params:
            path_params['project'] = params['project']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'text/plain'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['TokenAuth']  # noqa: E501

        return self.api_client.call_api(
            '/rest/Memberships/{project}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2005',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def destroy_membership(self, id, **kwargs):  # noqa: E501
        """destroy_membership  # noqa: E501

        Interact with an individual project membership.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.destroy_membership(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer identifying a membership. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.destroy_membership_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.destroy_membership_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def destroy_membership_with_http_info(self, id, **kwargs):  # noqa: E501
        """destroy_membership  # noqa: E501

        Interact with an individual project membership.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.destroy_membership_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer identifying a membership. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method destroy_membership" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `destroy_membership`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['TokenAuth']  # noqa: E501

        return self.api_client.call_api(
            '/rest/Membership/{id}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def partial_update_membership(self, id, **kwargs):  # noqa: E501
        """partial_update_membership  # noqa: E501

        Interact with an individual project membership.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.partial_update_membership(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer identifying a membership. (required)
        :param Body15 body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.partial_update_membership_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.partial_update_membership_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def partial_update_membership_with_http_info(self, id, **kwargs):  # noqa: E501
        """partial_update_membership  # noqa: E501

        Interact with an individual project membership.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.partial_update_membership_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer identifying a membership. (required)
        :param Body15 body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method partial_update_membership" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `partial_update_membership`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['TokenAuth']  # noqa: E501

        return self.api_client.call_api(
            '/rest/Membership/{id}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def retrieve_membership(self, id, **kwargs):  # noqa: E501
        """retrieve_membership  # noqa: E501

        Interact with an individual project membership.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.retrieve_membership(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer identifying a membership. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.retrieve_membership_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.retrieve_membership_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def retrieve_membership_with_http_info(self, id, **kwargs):  # noqa: E501
        """retrieve_membership  # noqa: E501

        Interact with an individual project membership.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.retrieve_membership_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer identifying a membership. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_membership" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `retrieve_membership`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['TokenAuth']  # noqa: E501

        return self.api_client.call_api(
            '/rest/Membership/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def retrieve_membership_list(self, project, **kwargs):  # noqa: E501
        """retrieve_membership_list  # noqa: E501

        Create or retrieve a list of project memberships.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.retrieve_membership_list(project, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int project: A unique integer identifying a project. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.retrieve_membership_list_with_http_info(project, **kwargs)  # noqa: E501
        else:
            (data) = self.retrieve_membership_list_with_http_info(project, **kwargs)  # noqa: E501
            return data

    def retrieve_membership_list_with_http_info(self, project, **kwargs):  # noqa: E501
        """retrieve_membership_list  # noqa: E501

        Create or retrieve a list of project memberships.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.retrieve_membership_list_with_http_info(project, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int project: A unique integer identifying a project. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_membership_list" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project' is set
        if ('project' not in params or
                params['project'] is None):
            raise ValueError("Missing the required parameter `project` when calling `retrieve_membership_list`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project' in params:
            path_params['project'] = params['project']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['TokenAuth']  # noqa: E501

        return self.api_client.call_api(
            '/rest/Memberships/{project}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_membership(self, id, **kwargs):  # noqa: E501
        """update_membership  # noqa: E501

        Interact with an individual project membership.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_membership(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer identifying a membership. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_membership_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.update_membership_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def update_membership_with_http_info(self, id, **kwargs):  # noqa: E501
        """update_membership  # noqa: E501

        Interact with an individual project membership.  Memberships specify a permission level of a user to a project. There are currently five cumulative permission levels. `View Only` can only view a project and not change any data. `Can Edit` can create, modify, and delete annotations. `Can Transfer` can upload and download media. `Can Execute` can launch algorithm workflows. `Full Control` can change project settings, including inviting new members, project name, and project metadata schema.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_membership_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer identifying a membership. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_membership" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `update_membership`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['TokenAuth']  # noqa: E501

        return self.api_client.call_api(
            '/rest/Membership/{id}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
